#!/bin/bash

lockf="locked" # the file name of the write lock
npf="nprocshared"
dir_jobs="dir_jobs" #the directory of job pool
stopf="stop"
stopnodef="stopnode"
finished_jobs="finished" #the directory of finished jobs

#this function will check the write lock, if the lock existed, wait for random seconds.
function checkwait()
{
    countdown=30
    while [ -f $1 -a $countdown -gt 0 ]; do
        t=`expr $RANDOM % 30 + 5`
        echo "wait for $t seconds."
        sleep $t
        ((countdown--))
    done
    return $countdown
}

#check if writable
checkwait $lockf
ret=$?
echo $ret
if [ $ret -le 0 ]; then
exit -1
#this process wait too many times, exit with signal -1.
else 
    touch $lockf
    #create a write lock
if [ -z $SLURM_STEP_ID ]; then
dir_current="$SLURM_JOB_ID-$SLURMD_NODENAME"
    else
	    dir_current="$SLURM_JOB_ID.$SLURM_STEP_ID-$SLURMD_NODENAME"
    fi
mkdir $dir_current
#make a work directory for the process
    rm $lockf
fi

checkwait $lockf
ret=$?
while [ $ret -gt 0 ]; do
    touch $lockf
    if [ -f $stopf ]; then
        stp=`cat $stopf`
        if [ $stp -le 1 -o -z $stp ]; then
            rm $stopf
        else
            cat $((stp-1)) > $stopf
        fi
        rm $lockf
        exit 0
    else
        #check the left jobs 
cd $dir_jobs
        inf=`find \( -name '*.com' -o -name '*.gjf' \) -type f | sed "s/^\.\///"`
        if [ -z "$inf" ];then
            #echo "proc $np has finished!"
            date
            echo "proc $np has finished!"
            rm ../$lockf
            #echo "proc $np has finished!"
            exit 0
        fi
        #move the earliest submitted job to the work directory
inf=`ls -t $inf | tail -n 1`
        cd ..
        suffix=${inf##*.}
      
        if [ "$suffix" == 'gjf' -o "$suffix" == 'com' ]; then
            outf=${inf%.*}'.log'
            chkf=${inf%.*}'.chk'
        else
            outf=$inf'.log'
            chkf=$inf'.chk'
        fi
        mv $dir_jobs/$inf $dir_current
        if [ -f $dir_jobs/$chkf ]; then
            mv $dir_jobs/$chkf $dir_current
        fi
        rm $lockf
    fi
    #sleep 1s
    cd $dir_current
    echo "================================================================"
    echo "start running at $(date)"
    echo "$dir_current"
    echo "$SLURM_TASK_PID"
    echo "g09 < $inf > $outf"
    echo $SLURMD_NODENAME
    g09 < $inf > $outf
    mv $inf $outf ../$finished_jobs
    if [ -f $chkf ]; then
        mv $chkf ../$finished_jobs
    fi
    echo "finised at $(date)"
    echo "================================================================"
    echo ""
    if [ -f $stopnodef ]; then
        date
        echo "$dir_current has been stopped!"
        rm $stopnodef
        exit 0
    fi
    cd ..
    checkwait $lockf
    ret=$?
done
echo $ret

